diff --git a/scrub/Makefile.in b/scrub/Makefile.in
index a8bb06b..1744941 100644
--- a/scrub/Makefile.in
+++ b/scrub/Makefile.in
@@ -11,8 +11,8 @@ INSTALL = @INSTALL@
 
 @MCONFIG@
 
-PROGS=		e2scrub
-MANPAGES=	e2scrub.8
+PROGS=		e2scrub e2scrub_all
+MANPAGES=	e2scrub.8 e2scrub_all.8
 CONFFILES=	e2scrub.conf
 
 ifeq ($(HAVE_UDEV),yes)
@@ -29,6 +29,11 @@ e2scrub: $(DEP_SUBSTITUTE) e2scrub.in
 	$(Q) $(SUBSTITUTE_UPTIME) $(srcdir)/e2scrub.in $@
 	$(Q) chmod a+x $@
 
+e2scrub_all: e2scrub_all.in
+	$(E) "	SUBST $@"
+	$(Q) $(SUBSTITUTE_UPTIME) $(srcdir)/e2scrub_all.in $@
+	$(Q) chmod a+x $@
+
 %.8: %.8.in $(DEP_SUBSTITUTE)
 	$(E) "	SUBST $@"
 	$(Q) $(SUBSTITUTE_UPTIME) $< $@
diff --git a/scrub/e2scrub.conf.in b/scrub/e2scrub.conf.in
index d578cc7..69f997f 100644
--- a/scrub/e2scrub.conf.in
+++ b/scrub/e2scrub.conf.in
@@ -8,3 +8,6 @@
 
 # Arguments passed into e2fsck.
 # e2fsck_opts="-vtt"
+
+# Set this to 1 to have e2scrub_all scrub all LVs, not just the mounted ones.
+# scrub_all=0
diff --git a/scrub/e2scrub_all.8.in b/scrub/e2scrub_all.8.in
new file mode 100644
index 0000000..ba3b873
--- /dev/null
+++ b/scrub/e2scrub_all.8.in
@@ -0,0 +1,36 @@
+.TH E2SCRUB 8 "@E2FSPROGS_MONTH@ @E2FSPROGS_YEAR@" "E2fsprogs version @E2FSPROGS_VERSION@"
+.SH NAME
+e2scrub_all - check all mounted ext[234] filesystems for errors.
+.SH SYNOPSYS
+.B
+e2scrub_all [OPTION]
+.SH DESCRIPTION
+Searches the system for all LVM logical volumes containing an ext2, ext3, or
+ext4 file system, and checks them for problems.
+The checking is performed by invoking the
+.B e2scrub
+tool, which will look for corruptions.
+Corrupt filesystems will be tagged as having errors so that fsck will be
+invoked before the next mount.
+If no errors are encountered,
+.B fstrim
+will be called on the filesystem if it is mounted.
+See the
+.B e2scrub
+manual page for more information about how the checking is performed.
+.SH OPTIONS
+.TP
+\fB-A\fR
+Scrub all ext[234] filesystems even if they are not mounted.
+.TP
+\fB-r\fR
+Remove e2scrub snapshots but do not check anything.
+.TP
+\fB-V\fR
+Print version information and exit.
+.SH SEE ALSO
+.BR e2scrub "(8)"
+.SH AUTHOR
+Darrick J. Wong <darrick.wong@oracle.com>
+.SH COPYRIGHT
+Copyright ©2018 Oracle.  License is GPLv2+. <http://www.gnu.org/licenses/gpl-2.0.html>
diff --git a/scrub/e2scrub_all.in b/scrub/e2scrub_all.in
new file mode 100644
index 0000000..b9e5dea
--- /dev/null
+++ b/scrub/e2scrub_all.in
@@ -0,0 +1,85 @@
+#!/bin/bash
+
+#  Copyright (C) 2018 Oracle.  All Rights Reserved.
+#
+#  Author: Darrick J. Wong <darrick.wong@oracle.com>
+#
+#  This program is free software; you can redistribute it and/or
+#  modify it under the terms of the GNU General Public License
+#  as published by the Free Software Foundation; either version 2
+#  of the License, or (at your option) any later version.
+#
+#  This program is distributed in the hope that it would be useful,
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#  GNU General Public License for more details.
+#
+#  You should have received a copy of the GNU General Public License
+#  along with this program; if not, write the Free Software Foundation,
+#  Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+
+scrub_all=0
+conffile="@root_sysconfdir@/e2scrub.conf"
+
+test -f "${conffile}" && . "${conffile}"
+
+scrub_args=""
+
+print_help() {
+	echo "Usage: $0 [OPTIONS]"
+	echo " -A: Scrub all ext[234] filesystems even if not mounted."
+	echo " -r: Remove e2scrub snapshots."
+	echo " -V: Print version information and exit."
+}
+
+print_version() {
+	echo "e2scrub_all @E2FSPROGS_VERSION@ (@E2FSPROGS_DATE@)"
+}
+
+while getopts "ArV" opt; do
+	case "${opt}" in
+	"A") scrub_all=1;;
+	"r") scrub_args="${scrub_args} -r";;
+	"V") print_version; exit 0;;
+	*) print_help; exit 2;;
+	esac
+done
+shift "$((OPTIND - 1))"
+
+# Find scrub targets, make sure we only do this once.
+ls_scrub_targets() {
+	lsblk -o NAME,FSTYPE,MOUNTPOINT -p -P -n | while read vars; do
+		eval "${vars}"
+
+		# Skip non-ext[234]
+		case "${FSTYPE}" in
+		ext[234])	;;
+		*)		continue;;
+		esac
+
+		# Skip unmounted filesystems unless -A
+		if [ "${scrub_all}" -eq 0 ] && [ -z "${MOUNTPOINT}" ]; then
+			continue;
+		fi
+
+		# Skip non-lvm devices and lvm snapshots
+		lvm_vars="$(lvs --nameprefixes -o vg_name,lv_name,lv_role --noheadings "${NAME}" 2> /dev/null)"
+		test $? -ne 0 && continue
+		eval "${lvm_vars}"
+		echo "${LVM2_LV_ROLE}" | grep -q "snapshot" && continue
+
+		if [ -n "${MOUNTPOINT}" ]; then
+			echo "${MOUNTPOINT}"
+		else
+			echo "${NAME}"
+		fi
+	done | sort | uniq
+}
+
+# Scrub any mounted fs on lvm by creating a snapshot and fscking that.
+stdin="$(realpath /dev/stdin)"
+ls_scrub_targets | while read tgt; do
+	${DBG} "@root_sbindir@/e2scrub" ${scrub_args} "${tgt}" < "${stdin}"
+done
+
+exit 0
